//
// Simple bump fragment shader
//
#extension GL_EXT_texture_aray: enable

varying	vec3 lt;
varying	vec3 ht;
uniform sampler2DArray map;

void main (void)
{
	vec4	clr   = texture2DArray ( map, vec3 ( gl_TexCoord [0].xy, 0.0 ) );		// get color
	vec4	n     = texture2DArray ( map, vec3 ( gl_TexCoord [0].xy, 1.0 ) );		// get normal
	vec4	gloss = texture2DArray ( map, vec3 ( gl_TexCoord [0].xy, 2.0 ) );		// get gloss color
	const	vec4	specColor = vec4 ( 1 );

	vec3	nt   = normalize ( vec3 ( 0.0, 0.0, 1.0 ) + 2.0*n.xyz - 1.0 );
	vec3	l2   = normalize ( lt );
	vec3	h2   = normalize ( ht );
	float	diff = max ( dot ( nt, l2 ), 0.0 ) + 0.2;
	float	spec = pow ( max ( dot ( nt, h2 ), 0.0 ), 60.0 );

	gl_FragColor = diff * clr + spec * gloss;
}
